%%
a = zeros(1, 3);
while 1
    m = randi([3,10]);
    n = randi([m*(m+1), 2*m*(m+1)]);
    A = randn(m,n);
    if rank(A) ~= m
        a(1) = a(1) + 1;
    end
    u = minvol(A);
    sum(u>0);
    m*(m+1)/2;
    if sum(u>0) > m*(m+1)/2
        a(1) = a(1) + 1;
    elseif sum(u>0) == m*(m+1)/2
        a(2) = a(2) + 1;
    else
        a(3) = a(3) + 1;
    end
end

%%
m = 5;
n = 10;
u = minvol(randn(m,n),1/3);
sum(u>0)
m*(m+1)/2


%%
total_time = 1000;
error_prob = 0;
for ii = 1:total_time
    d = 7;
    K = 50;
    T = 150;
    theta = randn(d, 1);
    A = randn(7, 50);
    [~ , I] = max(theta' * A);
    best_arm = myalgo(theta, A, T);
    if I ~= best_arm
        error_prob = error_prob + 1;
    end
end
error_prob / total_time

%%
total_time = 1000;
error_prob = 0;
for ii = 1:total_time
    d = 7;
    K = 50;
    T = 150;
    theta = randn(d, 1);
    A = randn(7, 50);
    [~ , I] = max(theta' * A);
    best_arm = Sequential_Halving(theta, A, T);
    if I ~= best_arm
        error_prob = error_prob + 1;
    end
end
error_prob / total_time


%%
total_time = 100;
error_prob = 0;
for ii = 1:total_time
    d = 7;
    K = 50;
    T = 150;
    theta = randn(d, 1);
    A = randn(7, 50);
    [~ , I] = max(theta' * A);
    best_arm = BayesGap_Oracle(theta, A, T);
    if I ~= best_arm
        error_prob = error_prob + 1;
    end
end
error_prob / total_time


%%
total_time = 100;
error_prob = 0;
for ii = 1:total_time
    d = 7;
    K = 50;
    T = 150;
    theta = randn(d, 1);
    A = randn(7, 50);
    [~ , I] = max(theta' * A);
    best_arm = BayesGap_Adaptive(theta, A, T);
    if I ~= best_arm
        error_prob = error_prob + 1;
    end
end
error_prob / total_time


%%
total_time = 100;
error_prob = zeros(1, 4);
d = 5;
K = 100;
T = 500;
for ii = 1:total_time
    theta = randn(d, 1);
    A = 0.1 * randn(d, K);
    [~ , I] = max(theta' * A);
    best_arm = myalgo(theta, A, T);
    if I ~= best_arm
        error_prob(1) = error_prob(1) + 1;
    end
    best_arm = Sequential_Halving(theta, A, T);
    if I ~= best_arm
        error_prob(2) = error_prob(2) + 1;
    end
    best_arm = BayesGap_Oracle(theta, A, T);
    if I ~= best_arm
        error_prob(3) = error_prob(3) + 1;
    end
    best_arm = BayesGap_Adaptive(theta, A, T);
    if I ~= best_arm
        error_prob(4) = error_prob(4) + 1;
    end
end
error_prob / total_time


%%
total_time = 100;
error_prob = zeros(2, 6);
I = 15;
T = 500;
theta = 1:15;
A = eye(15)*10;
for ii = 1 : 6
    eta = 10^(ii-3);
    for jj = 1 : total_time
        best_arm = BayesGap_Oracle(theta, A, T, eta);
        if I ~= best_arm
            error_prob(1, ii) = error_prob(1, ii) + 1;
        end
        best_arm = BayesGap_Adaptive(theta, A, T, eta);
        if I ~= best_arm
            error_prob(2, ii) = error_prob(2, ii) + 1;
        end
    end
end

error_prob / total_time


%%
total_time = 10000;
error_prob = zeros(1, 4);
d = 5;
K = 240;
T = 600;
for ii = 1 : total_time
    theta = randn(d, 1);
    A = 0.1 * randn(d, K);
    [~ , I] = max(theta' * A);
    best_arm = myalgo(theta, A, T);
    if I ~= best_arm
        error_prob(1) = error_prob(1) + 1;
    end
    best_arm = Sequential_Halving(theta, A, T);
    if I ~= best_arm
        error_prob(2) = error_prob(2) + 1;
    end
    best_arm = BayesGap_Oracle(theta, A, T);
    if I ~= best_arm
        error_prob(3) = error_prob(3) + 1;
    end
    best_arm = BayesGap_Adaptive(theta, A, T);
    if I ~= best_arm
        error_prob(4) = error_prob(4) + 1;
    end
    error_prob
end
error_prob1 = error_prob / total_time

